lens-4.15.3: Lenses, Folds and Traversals

Copyright | (C) 2012-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | Safe
Language | Haskell98

Control.Lens.Internal.Zoom

Contents

- Zoom
- Magnify

Description

Synopsis

- newtype Focusing m s a = Focusing {
  - unfocusing :: m (s, a)
  }
- newtype FocusingWith w m s a = FocusingWith {
  - unfocusingWith :: m (s, a, w)
  }
- newtype FocusingPlus w k s a = FocusingPlus {
  - unfocusingPlus :: k (s, w) a
  }
- newtype FocusingOn f k s a = FocusingOn {
  - unfocusingOn :: k (f s) a
  }
- newtype FocusingMay k s a = FocusingMay {
  - unfocusingMay :: k (May s) a
  }
- newtype May a = May {
  - getMay :: Maybe a
  }
- newtype FocusingErr e k s a = FocusingErr {
  - unfocusingErr :: k (Err e s) a
  }
- newtype Err e a = Err {
  - getErr :: Either e a
  }
- newtype FocusingFree f m k s a = FocusingFree {
  - unfocusingFree :: k (Freed f m s) a
  }
- newtype Freed f m a = Freed {
  - getFreed :: FreeF f a (FreeT f m a)
  }
- newtype Effect m r a = Effect {
  - getEffect :: m r
  }
- newtype EffectRWS w st m s a = EffectRWS {
  - getEffectRWS :: st -> m (s, st, w)
  }

# Zoom

newtype Focusing m s a #

Used by `Zoom` to `zoom` into `StateT`.

Constructors

Focusing |
Fields unfocusing :: m (s, a)

Instances

Monad m => Functor (Focusing m s) # |
Methods fmap :: (a -> b) -> Focusing m s a -> Focusing m s b # (<$) :: a -> Focusing m s b -> Focusing m s a #
(Monad m, Monoid s) => Applicative (Focusing m s) # |
Methods pure :: a -> Focusing m s a # (<*>) :: Focusing m s (a -> b) -> Focusing m s a -> Focusing m s b # (*>) :: Focusing m s a -> Focusing m s b -> Focusing m s b # (<*) :: Focusing m s a -> Focusing m s b -> Focusing m s a #
(Monad m, Semigroup s) => Apply (Focusing m s) # |
Methods (<.>) :: Focusing m s (a -> b) -> Focusing m s a -> Focusing m s b # (.>) :: Focusing m s a -> Focusing m s b -> Focusing m s b # (<.) :: Focusing m s a -> Focusing m s b -> Focusing m s a #

newtype FocusingWith w m s a #

Used by `Zoom` to `zoom` into `RWST`.

Constructors

FocusingWith |
Fields unfocusingWith :: m (s, a, w)

Instances

Monad m => Functor (FocusingWith w m s) # |
Methods fmap :: (a -> b) -> FocusingWith w m s a -> FocusingWith w m s b # (<$) :: a -> FocusingWith w m s b -> FocusingWith w m s a #
(Monad m, Monoid s, Monoid w) => Applicative (FocusingWith w m s) # |
Methods pure :: a -> FocusingWith w m s a # (<*>) :: FocusingWith w m s (a -> b) -> FocusingWith w m s a -> FocusingWith w m s b # (*>) :: FocusingWith w m s a -> FocusingWith w m s b -> FocusingWith w m s b # (<*) :: FocusingWith w m s a -> FocusingWith w m s b -> FocusingWith w m s a #
(Monad m, Semigroup s, Semigroup w) => Apply (FocusingWith w m s) # |
Methods (<.>) :: FocusingWith w m s (a -> b) -> FocusingWith w m s a -> FocusingWith w m s b # (.>) :: FocusingWith w m s a -> FocusingWith w m s b -> FocusingWith w m s b # (<.) :: FocusingWith w m s a -> FocusingWith w m s b -> FocusingWith w m s a #

newtype FocusingPlus w k s a #

Used by `Zoom` to `zoom` into `WriterT`.

Constructors

FocusingPlus |
Fields unfocusingPlus :: k (s, w) a

Instances

Functor (k (s, w)) => Functor (FocusingPlus w k s) # |
Methods fmap :: (a -> b) -> FocusingPlus w k s a -> FocusingPlus w k s b # (<$) :: a -> FocusingPlus w k s b -> FocusingPlus w k s a #
Applicative (k (s, w)) => Applicative (FocusingPlus w k s) # |
Methods pure :: a -> FocusingPlus w k s a # (<*>) :: FocusingPlus w k s (a -> b) -> FocusingPlus w k s a -> FocusingPlus w k s b # (*>) :: FocusingPlus w k s a -> FocusingPlus w k s b -> FocusingPlus w k s b # (<*) :: FocusingPlus w k s a -> FocusingPlus w k s b -> FocusingPlus w k s a #
Apply (k (s, w)) => Apply (FocusingPlus w k s) # |
Methods (<.>) :: FocusingPlus w k s (a -> b) -> FocusingPlus w k s a -> FocusingPlus w k s b # (.>) :: FocusingPlus w k s a -> FocusingPlus w k s b -> FocusingPlus w k s b # (<.) :: FocusingPlus w k s a -> FocusingPlus w k s b -> FocusingPlus w k s a #

newtype FocusingOn f k s a #

Used by `Zoom` to `zoom` into `MaybeT` or `ListT`.

Constructors

FocusingOn |
Fields unfocusingOn :: k (f s) a

Instances

Functor (k (f s)) => Functor (FocusingOn f k s) # |
Methods fmap :: (a -> b) -> FocusingOn f k s a -> FocusingOn f k s b # (<$) :: a -> FocusingOn f k s b -> FocusingOn f k s a #
Applicative (k (f s)) => Applicative (FocusingOn f k s) # |
Methods pure :: a -> FocusingOn f k s a # (<*>) :: FocusingOn f k s (a -> b) -> FocusingOn f k s a -> FocusingOn f k s b # (*>) :: FocusingOn f k s a -> FocusingOn f k s b -> FocusingOn f k s b # (<*) :: FocusingOn f k s a -> FocusingOn f k s b -> FocusingOn f k s a #
Apply (k (f s)) => Apply (FocusingOn f k s) # |
Methods (<.>) :: FocusingOn f k s (a -> b) -> FocusingOn f k s a -> FocusingOn f k s b # (.>) :: FocusingOn f k s a -> FocusingOn f k s b -> FocusingOn f k s b # (<.) :: FocusingOn f k s a -> FocusingOn f k s b -> FocusingOn f k s a #

newtype FocusingMay k s a #

Used by `Zoom` to `zoom` into `ErrorT`.

Constructors

FocusingMay |
Fields unfocusingMay :: k (May s) a

Instances

Functor (k (May s)) => Functor (FocusingMay k s) # |
Methods fmap :: (a -> b) -> FocusingMay k s a -> FocusingMay k s b # (<$) :: a -> FocusingMay k s b -> FocusingMay k s a #
Applicative (k (May s)) => Applicative (FocusingMay k s) # |
Methods pure :: a -> FocusingMay k s a # (<*>) :: FocusingMay k s (a -> b) -> FocusingMay k s a -> FocusingMay k s b # (*>) :: FocusingMay k s a -> FocusingMay k s b -> FocusingMay k s b # (<*) :: FocusingMay k s a -> FocusingMay k s b -> FocusingMay k s a #
Apply (k (May s)) => Apply (FocusingMay k s) # |
Methods (<.>) :: FocusingMay k s (a -> b) -> FocusingMay k s a -> FocusingMay k s b # (.>) :: FocusingMay k s a -> FocusingMay k s b -> FocusingMay k s b # (<.) :: FocusingMay k s a -> FocusingMay k s b -> FocusingMay k s a #

newtype May a #

Make a `Monoid` out of `Maybe` for error handling.

Constructors

May |
Fields getMay :: Maybe a

Instances

Semigroup a => Semigroup (May a) # |
Methods (<>) :: May a -> May a -> May a # sconcat :: NonEmpty (May a) -> May a # stimes :: Integral b => b -> May a -> May a #
Monoid a => Monoid (May a) # |
Methods mempty :: May a # mappend :: May a -> May a -> May a # mconcat :: [May a] -> May a #

newtype FocusingErr e k s a #

Used by `Zoom` to `zoom` into `ErrorT`.

Constructors

FocusingErr |
Fields unfocusingErr :: k (Err e s) a

Instances

Functor (k (Err e s)) => Functor (FocusingErr e k s) # |
Methods fmap :: (a -> b) -> FocusingErr e k s a -> FocusingErr e k s b # (<$) :: a -> FocusingErr e k s b -> FocusingErr e k s a #
Applicative (k (Err e s)) => Applicative (FocusingErr e k s) # |
Methods pure :: a -> FocusingErr e k s a # (<*>) :: FocusingErr e k s (a -> b) -> FocusingErr e k s a -> FocusingErr e k s b # (*>) :: FocusingErr e k s a -> FocusingErr e k s b -> FocusingErr e k s b # (<*) :: FocusingErr e k s a -> FocusingErr e k s b -> FocusingErr e k s a #
Apply (k (Err e s)) => Apply (FocusingErr e k s) # |
Methods (<.>) :: FocusingErr e k s (a -> b) -> FocusingErr e k s a -> FocusingErr e k s b # (.>) :: FocusingErr e k s a -> FocusingErr e k s b -> FocusingErr e k s b # (<.) :: FocusingErr e k s a -> FocusingErr e k s b -> FocusingErr e k s a #

newtype Err e a #

Make a `Monoid` out of `Either` for error handling.

Constructors

Err |
Fields getErr :: Either e a

Instances

Semigroup a => Semigroup (Err e a) # |
Methods (<>) :: Err e a -> Err e a -> Err e a # sconcat :: NonEmpty (Err e a) -> Err e a # stimes :: Integral b => b -> Err e a -> Err e a #
Monoid a => Monoid (Err e a) # |
Methods mempty :: Err e a # mappend :: Err e a -> Err e a -> Err e a # mconcat :: [Err e a] -> Err e a #

newtype FocusingFree f m k s a #

Used by `Zoom` to `zoom` into `FreeT`

Constructors

FocusingFree |
Fields unfocusingFree :: k (Freed f m s) a

Instances

Functor (k (Freed f m s)) => Functor (FocusingFree f m k s) # |
Methods fmap :: (a -> b) -> FocusingFree f m k s a -> FocusingFree f m k s b # (<$) :: a -> FocusingFree f m k s b -> FocusingFree f m k s a #
Applicative (k (Freed f m s)) => Applicative (FocusingFree f m k s) # |
Methods pure :: a -> FocusingFree f m k s a # (<*>) :: FocusingFree f m k s (a -> b) -> FocusingFree f m k s a -> FocusingFree f m k s b # (*>) :: FocusingFree f m k s a -> FocusingFree f m k s b -> FocusingFree f m k s b # (<*) :: FocusingFree f m k s a -> FocusingFree f m k s b -> FocusingFree f m k s a #
Apply (k (Freed f m s)) => Apply (FocusingFree f m k s) # |
Methods (<.>) :: FocusingFree f m k s (a -> b) -> FocusingFree f m k s a -> FocusingFree f m k s b # (.>) :: FocusingFree f m k s a -> FocusingFree f m k s b -> FocusingFree f m k s b # (<.) :: FocusingFree f m k s a -> FocusingFree f m k s b -> FocusingFree f m k s a #

newtype Freed f m a #

Make a `Monoid` out of `FreeF` for result collection.

Constructors

Freed |
Fields getFreed :: FreeF f a (FreeT f m a)

Instances

(Applicative f, Semigroup a, Monad m) => Semigroup (Freed f m a) # |
Methods (<>) :: Freed f m a -> Freed f m a -> Freed f m a # sconcat :: NonEmpty (Freed f m a) -> Freed f m a # stimes :: Integral b => b -> Freed f m a -> Freed f m a #
(Applicative f, Monoid a, Monad m) => Monoid (Freed f m a) # |
Methods mempty :: Freed f m a # mappend :: Freed f m a -> Freed f m a -> Freed f m a # mconcat :: [Freed f m a] -> Freed f m a #

# Magnify

newtype Effect m r a #

Wrap a monadic effect with a phantom type argument.

Constructors

Effect |
Fields getEffect :: m r

Instances

Functor (Effect m r) # |
Methods fmap :: (a -> b) -> Effect m r a -> Effect m r b # (<$) :: a -> Effect m r b -> Effect m r a #
(Monad m, Monoid r) => Applicative (Effect m r) # |
Methods pure :: a -> Effect m r a # (<*>) :: Effect m r (a -> b) -> Effect m r a -> Effect m r b # (*>) :: Effect m r a -> Effect m r b -> Effect m r b # (<*) :: Effect m r a -> Effect m r b -> Effect m r a #
Contravariant (Effect m r) # |
Methods contramap :: (a -> b) -> Effect m r b -> Effect m r a # (>$) :: b -> Effect m r b -> Effect m r a #
(Apply m, Semigroup r) => Apply (Effect m r) # |
Methods (<.>) :: Effect m r (a -> b) -> Effect m r a -> Effect m r b # (.>) :: Effect m r a -> Effect m r b -> Effect m r b # (<.) :: Effect m r a -> Effect m r b -> Effect m r a #
(Apply m, Semigroup r) => Semigroup (Effect m r a) # |
Methods (<>) :: Effect m r a -> Effect m r a -> Effect m r a # sconcat :: NonEmpty (Effect m r a) -> Effect m r a # stimes :: Integral b => b -> Effect m r a -> Effect m r a #
(Monad m, Monoid r) => Monoid (Effect m r a) # |
Methods mempty :: Effect m r a # mappend :: Effect m r a -> Effect m r a -> Effect m r a # mconcat :: [Effect m r a] -> Effect m r a #

newtype EffectRWS w st m s a #

Wrap a monadic effect with a phantom type argument. Used when magnifying `RWST`.

Constructors

EffectRWS |
Fields getEffectRWS :: st -> m (s, st, w)

Instances

Functor (EffectRWS w st m s) # |
Methods fmap :: (a -> b) -> EffectRWS w st m s a -> EffectRWS w st m s b # (<$) :: a -> EffectRWS w st m s b -> EffectRWS w st m s a #
(Monoid s, Monoid w, Monad m) => Applicative (EffectRWS w st m s) # |
Methods pure :: a -> EffectRWS w st m s a # (<*>) :: EffectRWS w st m s (a -> b) -> EffectRWS w st m s a -> EffectRWS w st m s b # (*>) :: EffectRWS w st m s a -> EffectRWS w st m s b -> EffectRWS w st m s b # (<*) :: EffectRWS w st m s a -> EffectRWS w st m s b -> EffectRWS w st m s a #
Contravariant (EffectRWS w st m s) # |
Methods contramap :: (a -> b) -> EffectRWS w st m s b -> EffectRWS w st m s a # (>$) :: b -> EffectRWS w st m s b -> EffectRWS w st m s a #
(Semigroup s, Semigroup w, Bind m) => Apply (EffectRWS w st m s) # |
Methods (<.>) :: EffectRWS w st m s (a -> b) -> EffectRWS w st m s a -> EffectRWS w st m s b # (.>) :: EffectRWS w st m s a -> EffectRWS w st m s b -> EffectRWS w st m s b # (<.) :: EffectRWS w st m s a -> EffectRWS w st m s b -> EffectRWS w st m s a #